// SCSS variables are information about icon's compiled state, stored under its original file name
//
// .icon-home {
//   width: $icon-home-width;
// }
//
// The large array-like variables contain all information about a single icon
// $icon-home: x y offset_x offset_y width height total_width total_height image_path;
//
// At the bottom of this section, we provide information about the spritesheet itself
// $spritesheet: width height image $spritesheet-sprites;
$arrow-blue-name: 'arrow-blue';
$arrow-blue-x: 0px;
$arrow-blue-y: 570px;
$arrow-blue-offset-x: 0px;
$arrow-blue-offset-y: -570px;
$arrow-blue-width: 19px;
$arrow-blue-height: 35px;
$arrow-blue-total-width: 35px;
$arrow-blue-total-height: 1048px;
$arrow-blue-image: 'sprite.png';
$arrow-blue: (0px, 570px, 0px, -570px, 19px, 35px, 35px, 1048px, 'sprite.png', 'arrow-blue', );
$arrow-blue2-name: 'arrow-blue2';
$arrow-blue2-x: 0px;
$arrow-blue2-y: 705px;
$arrow-blue2-offset-x: 0px;
$arrow-blue2-offset-y: -705px;
$arrow-blue2-width: 19px;
$arrow-blue2-height: 35px;
$arrow-blue2-total-width: 35px;
$arrow-blue2-total-height: 1048px;
$arrow-blue2-image: 'sprite.png';
$arrow-blue2: (0px, 705px, 0px, -705px, 19px, 35px, 35px, 1048px, 'sprite.png', 'arrow-blue2', );
$arrow-down-name: 'arrow-down';
$arrow-down-x: 0px;
$arrow-down-y: 334px;
$arrow-down-offset-x: 0px;
$arrow-down-offset-y: -334px;
$arrow-down-width: 35px;
$arrow-down-height: 18px;
$arrow-down-total-width: 35px;
$arrow-down-total-height: 1048px;
$arrow-down-image: 'sprite.png';
$arrow-down: (0px, 334px, 0px, -334px, 35px, 18px, 35px, 1048px, 'sprite.png', 'arrow-down', );
$arrow-left-name: 'arrow-left';
$arrow-left-x: 0px;
$arrow-left-y: 840px;
$arrow-left-offset-x: 0px;
$arrow-left-offset-y: -840px;
$arrow-left-width: 28px;
$arrow-left-height: 54px;
$arrow-left-total-width: 35px;
$arrow-left-total-height: 1048px;
$arrow-left-image: 'sprite.png';
$arrow-left: (0px, 840px, 0px, -840px, 28px, 54px, 35px, 1048px, 'sprite.png', 'arrow-left', );
$arrow-right-name: 'arrow-right';
$arrow-right-x: 0px;
$arrow-right-y: 994px;
$arrow-right-offset-x: 0px;
$arrow-right-offset-y: -994px;
$arrow-right-width: 28px;
$arrow-right-height: 54px;
$arrow-right-total-width: 35px;
$arrow-right-total-height: 1048px;
$arrow-right-image: 'sprite.png';
$arrow-right: (0px, 994px, 0px, -994px, 28px, 54px, 35px, 1048px, 'sprite.png', 'arrow-right', );
$arrow-up-name: 'arrow-up';
$arrow-up-x: 0px;
$arrow-up-y: 452px;
$arrow-up-offset-x: 0px;
$arrow-up-offset-y: -452px;
$arrow-up-width: 35px;
$arrow-up-height: 18px;
$arrow-up-total-width: 35px;
$arrow-up-total-height: 1048px;
$arrow-up-image: 'sprite.png';
$arrow-up: (0px, 452px, 0px, -452px, 35px, 18px, 35px, 1048px, 'sprite.png', 'arrow-up', );
$icon-email-name: 'icon-email';
$icon-email-x: 0px;
$icon-email-y: 106px;
$icon-email-offset-x: 0px;
$icon-email-offset-y: -106px;
$icon-email-width: 15px;
$icon-email-height: 12px;
$icon-email-total-width: 35px;
$icon-email-total-height: 1048px;
$icon-email-image: 'sprite.png';
$icon-email: (0px, 106px, 0px, -106px, 15px, 12px, 35px, 1048px, 'sprite.png', 'icon-email', );
$icon-phone-name: 'icon-phone';
$icon-phone-x: 0px;
$icon-phone-y: 218px;
$icon-phone-offset-x: 0px;
$icon-phone-offset-y: -218px;
$icon-phone-width: 16px;
$icon-phone-height: 16px;
$icon-phone-total-width: 35px;
$icon-phone-total-height: 1048px;
$icon-phone-image: 'sprite.png';
$icon-phone: (0px, 218px, 0px, -218px, 16px, 16px, 35px, 1048px, 'sprite.png', 'icon-phone', );
$name-icon-name: 'name-icon';
$name-icon-x: 0px;
$name-icon-y: 0px;
$name-icon-offset-x: 0px;
$name-icon-offset-y: 0px;
$name-icon-width: 15px;
$name-icon-height: 6px;
$name-icon-total-width: 35px;
$name-icon-total-height: 1048px;
$name-icon-image: 'sprite.png';
$name-icon: (0px, 0px, 0px, 0px, 15px, 6px, 35px, 1048px, 'sprite.png', 'name-icon', );
$arrow-blue2-2x-name: 'arrow-blue2@2x';
$arrow-blue2-2x-x: 0px;
$arrow-blue2-2x-y: 1140px;
$arrow-blue2-2x-offset-x: 0px;
$arrow-blue2-2x-offset-y: -1140px;
$arrow-blue2-2x-width: 38px;
$arrow-blue2-2x-height: 70px;
$arrow-blue2-2x-total-width: 70px;
$arrow-blue2-2x-total-height: 2096px;
$arrow-blue2-2x-image: 'sprite@2x.png';
$arrow-blue2-2x: (0px, 1140px, 0px, -1140px, 38px, 70px, 70px, 2096px, 'sprite@2x.png', 'arrow-blue2@2x', );
$arrow-blue-2x-name: 'arrow-blue@2x';
$arrow-blue-2x-x: 0px;
$arrow-blue-2x-y: 1410px;
$arrow-blue-2x-offset-x: 0px;
$arrow-blue-2x-offset-y: -1410px;
$arrow-blue-2x-width: 38px;
$arrow-blue-2x-height: 70px;
$arrow-blue-2x-total-width: 70px;
$arrow-blue-2x-total-height: 2096px;
$arrow-blue-2x-image: 'sprite@2x.png';
$arrow-blue-2x: (0px, 1410px, 0px, -1410px, 38px, 70px, 70px, 2096px, 'sprite@2x.png', 'arrow-blue@2x', );
$arrow-down-2x-name: 'arrow-down@2x';
$arrow-down-2x-x: 0px;
$arrow-down-2x-y: 668px;
$arrow-down-2x-offset-x: 0px;
$arrow-down-2x-offset-y: -668px;
$arrow-down-2x-width: 70px;
$arrow-down-2x-height: 36px;
$arrow-down-2x-total-width: 70px;
$arrow-down-2x-total-height: 2096px;
$arrow-down-2x-image: 'sprite@2x.png';
$arrow-down-2x: (0px, 668px, 0px, -668px, 70px, 36px, 70px, 2096px, 'sprite@2x.png', 'arrow-down@2x', );
$arrow-left-2x-name: 'arrow-left@2x';
$arrow-left-2x-x: 0px;
$arrow-left-2x-y: 1680px;
$arrow-left-2x-offset-x: 0px;
$arrow-left-2x-offset-y: -1680px;
$arrow-left-2x-width: 56px;
$arrow-left-2x-height: 108px;
$arrow-left-2x-total-width: 70px;
$arrow-left-2x-total-height: 2096px;
$arrow-left-2x-image: 'sprite@2x.png';
$arrow-left-2x: (0px, 1680px, 0px, -1680px, 56px, 108px, 70px, 2096px, 'sprite@2x.png', 'arrow-left@2x', );
$arrow-right-2x-name: 'arrow-right@2x';
$arrow-right-2x-x: 0px;
$arrow-right-2x-y: 1988px;
$arrow-right-2x-offset-x: 0px;
$arrow-right-2x-offset-y: -1988px;
$arrow-right-2x-width: 56px;
$arrow-right-2x-height: 108px;
$arrow-right-2x-total-width: 70px;
$arrow-right-2x-total-height: 2096px;
$arrow-right-2x-image: 'sprite@2x.png';
$arrow-right-2x: (0px, 1988px, 0px, -1988px, 56px, 108px, 70px, 2096px, 'sprite@2x.png', 'arrow-right@2x', );
$arrow-up-2x-name: 'arrow-up@2x';
$arrow-up-2x-x: 0px;
$arrow-up-2x-y: 904px;
$arrow-up-2x-offset-x: 0px;
$arrow-up-2x-offset-y: -904px;
$arrow-up-2x-width: 70px;
$arrow-up-2x-height: 36px;
$arrow-up-2x-total-width: 70px;
$arrow-up-2x-total-height: 2096px;
$arrow-up-2x-image: 'sprite@2x.png';
$arrow-up-2x: (0px, 904px, 0px, -904px, 70px, 36px, 70px, 2096px, 'sprite@2x.png', 'arrow-up@2x', );
$icon-email-2x-name: 'icon-email@2x';
$icon-email-2x-x: 0px;
$icon-email-2x-y: 212px;
$icon-email-2x-offset-x: 0px;
$icon-email-2x-offset-y: -212px;
$icon-email-2x-width: 30px;
$icon-email-2x-height: 24px;
$icon-email-2x-total-width: 70px;
$icon-email-2x-total-height: 2096px;
$icon-email-2x-image: 'sprite@2x.png';
$icon-email-2x: (0px, 212px, 0px, -212px, 30px, 24px, 70px, 2096px, 'sprite@2x.png', 'icon-email@2x', );
$icon-phone-2x-name: 'icon-phone@2x';
$icon-phone-2x-x: 0px;
$icon-phone-2x-y: 436px;
$icon-phone-2x-offset-x: 0px;
$icon-phone-2x-offset-y: -436px;
$icon-phone-2x-width: 32px;
$icon-phone-2x-height: 32px;
$icon-phone-2x-total-width: 70px;
$icon-phone-2x-total-height: 2096px;
$icon-phone-2x-image: 'sprite@2x.png';
$icon-phone-2x: (0px, 436px, 0px, -436px, 32px, 32px, 70px, 2096px, 'sprite@2x.png', 'icon-phone@2x', );
$name-icon-2x-name: 'name-icon@2x';
$name-icon-2x-x: 0px;
$name-icon-2x-y: 0px;
$name-icon-2x-offset-x: 0px;
$name-icon-2x-offset-y: 0px;
$name-icon-2x-width: 30px;
$name-icon-2x-height: 12px;
$name-icon-2x-total-width: 70px;
$name-icon-2x-total-height: 2096px;
$name-icon-2x-image: 'sprite@2x.png';
$name-icon-2x: (0px, 0px, 0px, 0px, 30px, 12px, 70px, 2096px, 'sprite@2x.png', 'name-icon@2x', );
$spritesheet-width: 35px;
$spritesheet-height: 1048px;
$spritesheet-image: 'sprite.png';
$spritesheet-sprites: ($arrow-blue, $arrow-blue2, $arrow-down, $arrow-left, $arrow-right, $arrow-up, $icon-email, $icon-phone, $name-icon, );
$spritesheet: (35px, 1048px, 'sprite.png', $spritesheet-sprites, );
$retina-spritesheet-width: 70px;
$retina-spritesheet-height: 2096px;
$retina-spritesheet-image: 'sprite@2x.png';
$retina-spritesheet-sprites: ($arrow-blue2-2x, $arrow-blue-2x, $arrow-down-2x, $arrow-left-2x, $arrow-right-2x, $arrow-up-2x, $icon-email-2x, $icon-phone-2x, $name-icon-2x, );
$retina-spritesheet: (70px, 2096px, 'sprite@2x.png', $retina-spritesheet-sprites, );

// These "retina group" variables are mappings for the naming and pairing of normal and retina sprites.
//
// The list formatted variables are intended for mixins like `retina-sprite` and `retina-sprites`.
$arrow-blue-group-name: 'arrow-blue';
$arrow-blue-group: ('arrow-blue', $arrow-blue, $arrow-blue2-2x, );
$arrow-blue2-group-name: 'arrow-blue2';
$arrow-blue2-group: ('arrow-blue2', $arrow-blue2, $arrow-blue-2x, );
$arrow-down-group-name: 'arrow-down';
$arrow-down-group: ('arrow-down', $arrow-down, $arrow-down-2x, );
$arrow-left-group-name: 'arrow-left';
$arrow-left-group: ('arrow-left', $arrow-left, $arrow-left-2x, );
$arrow-right-group-name: 'arrow-right';
$arrow-right-group: ('arrow-right', $arrow-right, $arrow-right-2x, );
$arrow-up-group-name: 'arrow-up';
$arrow-up-group: ('arrow-up', $arrow-up, $arrow-up-2x, );
$icon-email-group-name: 'icon-email';
$icon-email-group: ('icon-email', $icon-email, $icon-email-2x, );
$icon-phone-group-name: 'icon-phone';
$icon-phone-group: ('icon-phone', $icon-phone, $icon-phone-2x, );
$name-icon-group-name: 'name-icon';
$name-icon-group: ('name-icon', $name-icon, $name-icon-2x, );
$retina-groups: ($arrow-blue-group, $arrow-blue2-group, $arrow-down-group, $arrow-left-group, $arrow-right-group, $arrow-up-group, $icon-email-group, $icon-phone-group, $name-icon-group, );

// The provided mixins are intended to be used with the array-like variables
//
// .icon-home {
//   @include sprite-width($icon-home);
// }
//
// .icon-email {
//   @include sprite($icon-email);
// }
//
// Example usage in HTML:
//
// `display: block` sprite:
// <div class="icon-home"></div>
//
// To change `display` (e.g. `display: inline-block;`), we suggest using a common CSS class:
//
// // CSS
// .icon {
//   display: inline-block;
// }
//
// // HTML
// <i class="icon icon-home"></i>
@mixin sprite-width($sprite) {
  width: nth($sprite, 5);
}

@mixin sprite-height($sprite) {
  height: nth($sprite, 6);
}

@mixin sprite-position($sprite) {
  $sprite-offset-x: nth($sprite, 3);
  $sprite-offset-y: nth($sprite, 4);
  background-position: $sprite-offset-x  $sprite-offset-y;
}

@mixin sprite-image($sprite) {
  $sprite-image: nth($sprite, 9);
  background-image: url(#{$sprite-image});
}

@mixin sprite($sprite) {
  @include sprite-image($sprite);
  @include sprite-position($sprite);
  @include sprite-width($sprite);
  @include sprite-height($sprite);
}

// The `retina-sprite` mixin sets up rules and a media query for a sprite/retina sprite.
//   It should be used with a "retina group" variable.
//
// The media query is from CSS Tricks: https://css-tricks.com/snippets/css/retina-display-media-query/
//
// $icon-home-group: ('icon-home', $icon-home, $icon-home-2x, );
//
// .icon-home {
//   @include retina-sprite($icon-home-group);
// }
@mixin sprite-background-size($sprite) {
  $sprite-total-width: nth($sprite, 7);
  $sprite-total-height: nth($sprite, 8);
  background-size: $sprite-total-width $sprite-total-height;
}

@mixin retina-sprite($retina-group) {
  $normal-sprite: nth($retina-group, 2);
  $retina-sprite: nth($retina-group, 3);
  @include sprite($normal-sprite);

  @media (-webkit-min-device-pixel-ratio: 2),
         (min-resolution: 192dpi) {
    @include sprite-image($retina-sprite);
    @include sprite-background-size($normal-sprite);
  }
}

// The `sprites` mixin generates identical output to the CSS template
//   but can be overridden inside of SCSS
//
// @include sprites($spritesheet-sprites);
@mixin sprites($sprites) {
  @each $sprite in $sprites {
    $sprite-name: nth($sprite, 10);
    .#{$sprite-name} {
      @include sprite($sprite);
    }
  }
}

// The `retina-sprites` mixin generates a CSS rule and media query for retina groups
//   This yields the same output as CSS retina template but can be overridden in SCSS
//
// @include retina-sprites($retina-groups);
@mixin retina-sprites($retina-groups) {
  @each $retina-group in $retina-groups {
    $sprite-name: nth($retina-group, 1);
    .#{$sprite-name} {
      @include retina-sprite($retina-group);
    }
  }
}
